﻿package  {
	
	import flash.net.SharedObject;
	import flash.display.MovieClip;
	import fl.controls.TextArea;
	
	public class TestLSO extends MovieClip {

		var lso:SharedObject;
		
		public function TestLSO() {

			var oldVal:Number; 
			var newVal:Number;
			var retrievedVal:Number;
			
			
			var ta_log:TextArea = new TextArea();
			ta_log.x = 32;
			ta_log.y = 240;
			ta_log.height = 140; 
			ta_log.width = 500;
			addChild(ta_log);
			
			ta_log.text += "==== BEGIN Test ====\n";
			
			ta_log.text += " - Creating/Retrieving LSO\n";
		
			lso = SharedObject.getLocal("test-lso");
		
			if ("loadCount" in lso.data) { 
				ta_log.text += " - Reading from existing LSO\n\n";
			} else { 
				ta_log.text += "loadCount is undefined, initializing counter\n";
				lso.data.loadCount = 0;
			}
			
			ta_log.text += "==== Current Test Counter Value: " + lso.data.loadCount + " \n\n";
			

			ta_log.text += "*********************************************************** \n";
			ta_log.text += "Note: This counter value should persist through page loads. \n";
			ta_log.text += "It should also be cleared by any of the following: \n";
			ta_log.text += "- Clearing the browser cookies \n";
			ta_log.text += "- Control Panel/Settings > Flash Player > Storage > Delete All \n";
			ta_log.text += "- Existing your private browsing session \n\n";
			ta_log.text += "*********************************************************** \n\n";

			oldVal = lso.data.loadCount;
			newVal = lso.data.loadCount + 1; 
			ta_log.text += "==== Incrementing counter value to: " + newVal + "\n";
			

			lso.data.loadCount = newVal;
						
			
			try { 
				ta_log.text += "- Flushing value to disk \n";
				var flushResult:String = lso.flush();
				ta_log.text += "- Result: " + flushResult + "\n";
				
			} catch(e) { 
				MovieClip(root).tf_result.text = "FAIL";
				ta_log.text += "Flushing to disk failed: " + e.text + "\n";
			}
			
			ta_log.text += "Refreshing LSO from disk \n";
			
			lso = SharedObject.getLocal("test-lso");
			retrievedVal = lso.data.loadCount; 
			
			ta_log.text += "==== Value read from disk: " + retrievedVal + "\n";
			
			if (newVal == retrievedVal) { 
				MovieClip(root).tf_result.text = "PASS"; 
			} else { 
				MovieClip(root).tf_result.text = "FAIL"; 
				ta_log.text += "Test Failed.  The expected and actual values do not match.\n"; 
				ta_log.text += "Expected: " + newVal + "\n";
				ta_log.text += "Actual: "  + retrievedVal + "\n";
			}
			
			ta_log.text += "==== END Test ====\n";
			
		}
	}
}
